/***
 * OW2 FraSCAti Tinfi
 * Copyright (C) 2009 INRIA, USTL
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * Contact: frascati@ow2.org
 *
 * Author: Lionel Seinturier
 */

package org.ow2.frascati.tinfi.emf;

import java.io.PrintWriter;
import java.util.Set;

import org.objectweb.fractal.api.type.ComponentType;
import org.objectweb.fractal.juliac.FCSourceCodeGeneratorItf;
import org.objectweb.fractal.juliac.desc.AttributeDesc;
import org.ow2.frascati.tinfi.control.property.SCAPropertyController;

/**
 * This class extends the {@link
 * org.objectweb.fractal.juliac.desc.ComponentDesc} class from Juliac to
 * redefine the way attribute values are set.
 * 
 * @author Lionel Seinturier <Lionel.Seinturier@univ-lille1.fr>
 * @since 1.1
 */
public class ComponentDesc
extends org.objectweb.fractal.juliac.desc.ComponentDesc {

    public ComponentDesc(
        String id, String name, String definition,
        FCSourceCodeGeneratorItf<?> fcscg,
        ComponentType ct, String ctrlDesc, String contentClassName ) {
        
        super(id,name,definition,fcscg,ct,ctrlDesc,contentClassName);
    }
    
    @Override
    protected void generateAttributes( PrintWriter pw ) {
        
        String id = getID();
        Set<String> names = getAttributeNames();
        
        for (String name : names) {
            AttributeDesc adesc = getAttribute(name);
            String value = adesc.getValue();

            pw.print  ("((");
            pw.print  (SCAPropertyController.class.getName());
            pw.print  (")");
            pw.print  (id);
            pw.print  (".getFcInterface(\"");
            pw.print  (SCAPropertyController.NAME);
            pw.print  ("\")).setValue(\"");
            pw.print  (name);
            pw.print  ("\",\"");
            pw.print  (value);
            pw.println("\");");
        }
    }
}
